import es
import gamethread
import vecmath
import effectlib

info = es.AddonInfo()
info.basename = "grub"
info.name = "Antlion grub tracker"
info.version = "1.0"
info.author = "GODJonez"
info.tags = "ep2"

globaldata = {
    'ents': {},
    'grubsin': 0,
    'grubs': 0,
    'grubsmap': 0,
    'userid': 2,
    'mapname': "",
}

def hudmsg(users,msg,channel=1,x=-1,y=-1,
           r1=255,g1=255,b1=255,a1=255,r2=255,g2=255,b2=255,a2=255,
           effect=0,fadein=0.1,fadeout=0.1,holdtime=4.0,fxtime=0.0):
    es.usermsg('create','hudmsg','HudMsg')
    es.usermsg('write','byte','hudmsg', channel & 0xff)
    es.usermsg('write','float', 'hudmsg', x)
    es.usermsg('write','float', 'hudmsg', y)
    es.usermsg('write','byte', 'hudmsg', r1)
    es.usermsg('write','byte', 'hudmsg', g1)
    es.usermsg('write','byte', 'hudmsg', b1)
    es.usermsg('write','byte', 'hudmsg', a1)
    es.usermsg('write','byte', 'hudmsg', r2)
    es.usermsg('write','byte', 'hudmsg', g2)
    es.usermsg('write','byte', 'hudmsg', b2)
    es.usermsg('write','byte', 'hudmsg', a2)
    es.usermsg('write','byte', 'hudmsg', effect)
    es.usermsg('write','float', 'hudmsg', fadein)
    es.usermsg('write','float', 'hudmsg', fadeout)
    es.usermsg('write','float', 'hudmsg', holdtime)
    es.usermsg('write','float', 'hudmsg', fxtime)
    es.usermsg('write','string', 'hudmsg', msg)
    try:
        u = int(users)
        users = (u,)
    except:
        pass
    for user in users:
        userid = int(user)
        if es.exists('userid',userid):
            es.usermsg('send','hudmsg',userid)
    es.usermsg('delete','hudmsg')

def es_map_start(ev):
    mapname = str(ev['mapname'])
    es.msg('\x01Map: \x04%s'%mapname)
    gamethread.delayed(3, newmap, mapname)

def newmap(mapname):
    ents = map(int, es.createentitylist('npc_antlion_grub').keys())
    if mapname == globaldata['mapname']:
        globaldata['grubsmap'] = globaldata['grubsin'] - len(ents)
        globaldata['grubs'] -= (len(ents) - len(globaldata['ents']))
    else:
        globaldata['grubsin'] = len(ents)
        globaldata['grubsmap'] = 0
    globaldata['mapname'] = mapname
    globaldata['ents'] = ents

def entity_killed(ev):
    ent = int(ev['entindex_killed'])
    if ent in globaldata['ents']:
        globaldata['grubs'] += 1
        globaldata['grubsmap'] += 1
        text = 'Grubs killed: %d/%d (total: %d/333)'%(
            globaldata['grubsmap'], globaldata['grubsin'],
            globaldata['grubs'])
        hudmsg(globaldata['userid'], text, x=0.1, y=0.7)
        es.msg('\x01Grubs killed: \x03%d/%d\x01 (total: \x04%d/333\x01)'%(
            globaldata['grubsmap'], globaldata['grubsin'],
            globaldata['grubs'])
               )
        globaldata['ents'].remove(ent)

def findclosest(ploc):
    minent = 0
    mindist = 10000
    for ent in globaldata['ents']:
        entloc = vecmath.vector(es.getindexprop(ent, 'CBaseEntity.m_vecOrigin'))
        entdist = vecmath.distance(ploc, entloc)
        if entdist < mindist:
            minent = entloc
            mindist = entdist
    return (minent, mindist)

def load():
    es.addons.registerClientCommandFilter(ccf)

def unload():
    es.addons.unregisterClientCommandFilter(ccf)

def ccf(userid, args):
    if args[0] == "grubs":
        text = 'Grubs killed: %d/%d (total: %d/333)'%(
            globaldata['grubsmap'], globaldata['grubsin'],
            globaldata['grubs'])
        globaldata['userid'] = userid
        hudmsg(userid, text, x=0.1, y=0.7, b1=0, b2=0)
        ploc = vecmath.vector(es.getplayerlocation(userid))+(0,0,30)
        entloc, entdist = findclosest(ploc)
        if entloc:
            text = 'Distance: %.2f'%entdist
            hudmsg(userid, text, x=0.1, y=-1, r1=0, r2=0, channel=2)
            effectlib.drawLine(ploc, entloc, seconds=3)
